Imports istia.st.articles.dao
Imports istia.st.articles.domain
Imports System.Web.Services
Imports Spring.Context
Imports System.Configuration

Namespace istia.st.articles.webservice
	<System.Web.Services.WebService(Namespace:="istia.st.articles.webservice"), _
	System.Xml.Serialization.XmlIncludeAttribute(GetType(Achat))> _
	Public Class WebServiceArticles
		Inherits System.Web.Services.WebService
		Implements IArticlesWebService

		'champs privs
		Private articlesDomain As IArticlesDomain

		' constructeur
		Public Sub New()
			' classe de base
			MyBase.New()
			' on rcupre l'objet IArticlesDomain d'accs  la couche mtier
			articlesDomain = CType(Application.Item("articlesDomain"), IArticlesDomain)
		End Sub

		' liste de tous les articles
		<WebMethod()> _
		Public Function getAllArticles() As IList Implements IArticlesWebService.getAllArticles
			' liste de tous les articles
			Return articlesDomain.getAllArticles
		End Function

		' recherche d'un article
		<WebMethod()> _
		Public Function getArticleById(ByVal idArticle As Integer) As Article Implements IArticlesWebService.getArticleById
			' on rcupre l'article
			Dim article As article = articlesDomain.getArticleById(idArticle)
			' article trouv ?
			If article Is Nothing Then
				Throw New Exception(String.Format("L'article d'id [{0}] n'existe pas", idArticle))
			End If
			' on rend l'article
			Return article
		End Function

		' achat du panier
		<WebMethod()> _
		Public Function acheterPanier(ByVal panier As Panier) As WSPanier Implements IArticlesWebService.acheterpanier
			' on achte le panier
			articlesDomain.acheter(panier)
			' on prpare le rsultat
			Dim wspanier As New wspanier
			For i As Integer = 0 To panier.achats.Count - 1
				wspanier.ajouter(CType(panier.achats(i), Achat))
			Next
			wspanier.erreurs = articlesDomain.erreurs
			' on rend le rsultat
			Return wspanier
		End Function

		' test achat panier
		<WebMethod()> _
		Public Function testAchatPanier() As WSPanier Implements IArticlesWebService.testAchatPanier
			' le panier  acheter
			Dim unPanier As New Panier
			' on ajoute des achats fictifs
			unPanier.ajouter(New Achat(New Article(1, "article1", 100, 10, 10), 2))
			unPanier.ajouter(New Achat(New Article(2, "article2", 200, 20, 20), 200))
			' on rend le rsultat
			Return acheterPanier(unPanier)
		End Function

		' dbogage
		<WebMethod()> _
		Public Function status() As ArrayList Implements IArticlesWebService.status
			Dim infos As New ArrayList
			Dim texte As String
			If articlesDomain Is Nothing Then
				texte = "articlesDomain=nothing"
			Else
				texte = "articlesDomain<>nothing"
			End If
			infos.Add(texte)
			If Session Is Nothing Then
				texte = "Session=nothing"
			Else
				texte = "Session<>nothing"
			End If
			infos.Add(texte)
			Return infos
		End Function

	End Class

End Namespace
