﻿Imports System
Imports System.ComponentModel
Imports System.Diagnostics
Imports System.Web.Services
Imports System.Web.Services.Protocols
Imports System.Xml.Serialization
Imports istia.st.articles.dao
Imports istia.st.articles.domain
Imports istia.st.articles.webservice

' proxy d'accès au service web d'achats d'articles
Namespace istia.st.articles.proxy

	<System.Diagnostics.DebuggerStepThroughAttribute(), _
	 System.ComponentModel.DesignerCategoryAttribute("code"), _
	 System.Web.Services.WebServiceBindingAttribute(Name:="WebServiceArticlesSoap", [Namespace]:="istia.st.articles.webservice"), _
	 System.Xml.Serialization.XmlIncludeAttribute(GetType(Achat))> _
	Public Class WebServiceArticles
		Inherits System.Web.Services.Protocols.SoapHttpClientProtocol

		' constructeur
		Public Sub New(ByVal urlWebServiceArticles As String)
			MyBase.New()
			Me.Url = urlWebServiceArticles
		End Sub


		' achat du panier
		<System.Web.Services.Protocols.SoapDocumentMethodAttribute("istia.st.articles.webservice/acheterPanier", RequestNamespace:="istia.st.articles.webservice", ResponseNamespace:="istia.st.articles.webservice", Use:=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle:=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)> _
		Public Function acheterPanier(ByVal panier As Panier) As WSPanier
			Dim results() As Object = Me.Invoke("acheterPanier", New Object() {panier})
			Return CType(results(0), WSPanier)
		End Function

		Public Function BeginacheterPanier(ByVal panier As Panier, ByVal callback As System.AsyncCallback, ByVal asyncState As Object) As System.IAsyncResult
			Return Me.BeginInvoke("acheterPanier", New Object() {panier}, callback, asyncState)
		End Function

		Public Function EndacheterPanier(ByVal asyncResult As System.IAsyncResult) As WSPanier
			Dim results() As Object = Me.EndInvoke(asyncResult)
			Return CType(results(0), WSPanier)
		End Function

		' obtenir un article particulier
		<System.Web.Services.Protocols.SoapDocumentMethodAttribute("istia.st.articles.webservice/getArticleById", RequestNamespace:="istia.st.articles.webservice", ResponseNamespace:="istia.st.articles.webservice", Use:=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle:=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)> _
		Public Function getArticleById(ByVal idArticle As Integer) As Article
			Dim results() As Object = Me.Invoke("getArticleById", New Object() {idArticle})
			Return CType(results(0), Article)
		End Function

		Public Function BegingetArticleById(ByVal idArticle As Integer, ByVal callback As System.AsyncCallback, ByVal asyncState As Object) As System.IAsyncResult
			Return Me.BeginInvoke("getArticleById", New Object() {idArticle}, callback, asyncState)
		End Function

		Public Function EndgetArticleById(ByVal asyncResult As System.IAsyncResult) As Article
			Dim results() As Object = Me.EndInvoke(asyncResult)
			Return CType(results(0), Article)
		End Function

		' obtenir tous les articles
		<System.Web.Services.Protocols.SoapDocumentMethodAttribute("istia.st.articles.webservice/getAllArticles", RequestNamespace:="istia.st.articles.webservice", ResponseNamespace:="istia.st.articles.webservice", Use:=System.Web.Services.Description.SoapBindingUse.Literal, ParameterStyle:=System.Web.Services.Protocols.SoapParameterStyle.Wrapped)> _
		Public Function getAllArticles() As Object()
			Dim results() As Object = Me.Invoke("getAllArticles", New Object(-1) {})
			Return CType(results(0), Object())
		End Function

		Public Function BegingetAllArticles(ByVal callback As System.AsyncCallback, ByVal asyncState As Object) As System.IAsyncResult
			Return Me.BeginInvoke("getAllArticles", New Object(-1) {}, callback, asyncState)
		End Function

		Public Function EndgetAllArticles(ByVal asyncResult As System.IAsyncResult) As Object()
			Dim results() As Object = Me.EndInvoke(asyncResult)
			Return CType(results(0), Object())
		End Function

	End Class
End Namespace
