﻿Imports istia.st.articles.domain
Imports istia.st.articles.dao
Imports istia.st.articles.webservice

Namespace istia.st.articles.proxy
	Public Class WebServiceArticlesProxy
		Implements istia.st.articles.domain.IArticlesDomain

		' le proxy d'accès au service web
		Private _webServiceProxy As WebServiceArticles
		Public Property webServiceProxy() As WebServiceArticles
			Get
				Return _webServiceProxy
			End Get
			Set(ByVal Value As WebServiceArticles)
				_webServiceProxy = Value
			End Set
		End Property

		' les erreurs
		Private _erreurs As ArrayList
		Public ReadOnly Property erreurs() As ArrayList Implements IArticlesDomain.erreurs
			Get
				Return _erreurs
			End Get
		End Property

		' constructeur
		Public Sub New()
		End Sub

		' achat d'un panier
		Public Sub acheter(ByVal panier1 As Panier) Implements IArticlesDomain.acheter
			' on envoie panier1 au serveur - on reçoit en retour panier2
			Dim wsPanier2 As WSPanier = webServiceProxy.acheterPanier(panier1)
			' on note les erreurs
			_erreurs = wsPanier2.erreurs
			' on met les achats restants dans le panier original panier2 -> panier1
			For i As Integer = panier1.achats.Count - 1 To 0 Step -1
				panier1.enlever(CType(panier1.achats(i), Achat).article.id)
			Next
			For i As Integer = 0 To wsPanier2.achats.Count - 1
				panier1.ajouter(CType(wsPanier2.achats(i), Achat))
			Next
		End Sub

		' liste des articles
		Public Function getAllArticles() As IList Implements IArticlesDomain.getAllArticles
			Dim articles As New ArrayList
			Dim webServiceArticles As Object() = webServiceProxy.getAllArticles
			For i As Integer = 0 To webServiceArticles.Length - 1
				articles.Add(webServiceArticles(i))
			Next
			Return articles
		End Function

		' un article particulier
		Public Function getArticleById(ByVal idArticle As Integer) As Article Implements IArticlesDomain.getArticleById
			Return webServiceProxy.getArticleById(idArticle)
		End Function

	End Class

End Namespace
